
import scala.concurrent._
import scala.concurrent.duration._
import ExecutionContext.Implicits.global
import scala.language.postfixOps 



lazy val f = Future {
  assert(simp(ZERO | ONE) == ONE)
  assert(simp(STAR(ZERO | ONE)) == STAR(ZERO | ONE))
  assert(simp(ONE ~ (ONE ~ (ONE ~ CHAR('a')))) == CHAR('a'))
  assert(simp(ONE ~ (ONE ~ (ONE ~ ZERO))) == ZERO)
  assert(simp(ALT(ONE ~ (ONE ~ (ONE ~ ZERO)), CHAR('a'))) == CHAR('a'))
  assert(simp(CHAR('a') | CHAR('a')) == CHAR('a'))
  assert(simp(ONE | CHAR('a')) == (ONE | CHAR('a')))
}

Await.result(f, 30 second)
